import Blockly from 'blockly';
Blockly.Blocks.servo_init={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Start");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Servomotor");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/servo.gif",40,40,"*"));this.appendValueInput("pin").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Pin");this.appendValueInput("angle").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("\u00c1ngulo inicial");
this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.servo_init=function(a){var b=Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"angle",Blockly.Lua.ORDER_ATOMIC);return`pwm.setup(${b}, 123, 81+${a})
pwm.start(${b})
`};
Blockly.Blocks.servo_angle={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Cambiar \u00c1ngulo");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Servomotor");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/servo.gif",40,40,"*"));this.appendValueInput("pin").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Pin");this.appendValueInput("angle").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Nuevo \u00e1ngulo");this.setPreviousStatement(!0,
null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.servo_angle=function(a){var b=Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"angle",Blockly.Lua.ORDER_ATOMIC);return`pwm.setduty(${b},81+${a})
`};
Blockly.Blocks.servo_stop={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Detener");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Servomotor");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/servo.gif",40,40,"*"));this.appendValueInput("pin").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Pin");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);
this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.servo_stop=function(a){return`pwm.stop(${Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC)})
`};
Blockly.Blocks.ws2812_init={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/ws2812.png",30,30,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Iniciar ws2812");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldDropdown([["Simple pin:D4","ws2812.MODE_SINGLE"],["Dual pin:D4, TX","ws2812.MODE_DUAL"]]),"mode");this.setPreviousStatement(!0,null);
this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.ws2812_init=function(a){return`ws2812.init(${a.getFieldValue("mode")})
`};Blockly.Blocks.ws2812_format={init:function(){this.appendStatementInput("format").setCheck(null).appendField(new Blockly.FieldImage("https://http2.mlstatic.com/D_NQ_NP_718805-MLA31044696746_062019-Q.jpg",15,15,"*")).appendField("format");this.setInputsInline(!0);this.setOutput(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.ws2812_format=function(a){return[`string.char(${Blockly.Lua.statementToCode(a,"format")})`,Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.ws2812_array={init:function(){this.appendValueInput("R").setCheck("Number").setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/ws2812.png",15,15,"*")).appendField("R");this.appendValueInput("G").setCheck("Number").appendField("G");this.appendValueInput("B").setCheck("Number").appendField("B");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.ws2812_array=function(a){var b=Blockly.Lua.valueToCode(a,"R",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"G",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"B",Blockly.Lua.ORDER_ATOMIC);return`${c}, ${b}, ${a}, `};
Blockly.Blocks.ws2812_array_finish={init:function(){this.appendValueInput("R").setCheck("Number").setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/ws2812.png",15,15,"*")).appendField("R");this.appendValueInput("G").setCheck("Number").appendField("G");this.appendValueInput("B").setCheck("Number").appendField("B");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!1,null);this.setColour(290);this.setTooltip("");
this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.ws2812_array_finish=function(a){var b=Blockly.Lua.valueToCode(a,"R",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"G",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"B",Blockly.Lua.ORDER_ATOMIC);return`${c}, ${b}, ${a}`};
Blockly.Blocks.ws2812_write={init:function(){this.appendValueInput("write").setCheck("String").setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/ws2812.png",15,15,"*")).appendField("escribir (D4)");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.ws2812_write=function(a){return`ws2812.write(${Blockly.Lua.valueToCode(a,"write",Blockly.Lua.ORDER_ATOMIC)})
`};
Blockly.Blocks.ws2812_write_dual={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/ws2812.png",15,15,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Escribir");this.appendValueInput("write d4").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("en D4");this.appendValueInput("write tx").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("en TX");this.setPreviousStatement(!0,null);
this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.ws2812_write_dual=function(a){var b=Blockly.Lua.valueToCode(a,"write d4",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"write tx",Blockly.Lua.ORDER_ATOMIC);return`ws2812.write(${""==b?"nil":b}, ${""==a?"nil":a})
`};
Blockly.Blocks.display_oled_init={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/oled.jpg",30,30,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldVariable("item"),"disp");this.appendValueInput("id").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("id:");this.appendValueInput("sda").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("sda:");this.appendValueInput("scl").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("scl:");
this.appendValueInput("sla").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("sla:");this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField("velocidad:");this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldDropdown([["lento","i2c.SLOW"],["r\u00e1pido","i2c.FAST"],["muy r\u00e1pido","i2c.FASTPLUS"]]),"speed");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.display_oled_init=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("disp"),Blockly.Variables.NAME_TYPE),c=Blockly.Lua.valueToCode(a,"id",Blockly.Lua.ORDER_ATOMIC),d=Blockly.Lua.valueToCode(a,"sda",Blockly.Lua.ORDER_ATOMIC),e=Blockly.Lua.valueToCode(a,"scl",Blockly.Lua.ORDER_ATOMIC),f=Blockly.Lua.valueToCode(a,"sla",Blockly.Lua.ORDER_ATOMIC);a=a.getFieldValue("speed");return"i2c.setup("+c+", "+d+", "+e+", "+a+")\n"+b+" = u8g2.ssd1306_i2c_128x64_noname("+c+", "+f+")\n"+
b+":setFont(u8g2.font_6x10_tf)\n"+b+":setFontRefHeightExtendedText()\n"+b+":setDrawColor(1)\n"+b+":setFontPosTop()\n"};
Blockly.Blocks.display_oled_buffer={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/oled.jpg",15,15,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldVariable("item"),"disp");this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(":").appendField(new Blockly.FieldDropdown([["escribir_en_pantalla","sendBuffer()"],["limpiar_pantalla","clearBuffer()"]]),
"action");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.display_oled_buffer=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("disp"),Blockly.Variables.NAME_TYPE);a=a.getFieldValue("action");return b+":"+a+"\n"};
Blockly.Blocks.display_oled_angle_text={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/oled.jpg",15,15,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldVariable("item"),"disp");this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(":posici\u00f3n del texto").appendField(new Blockly.FieldDropdown([["0\u00ba","0"],["90\u00ba","3"],["180\u00ba","2"],
["270\u00ba","1"]]),"action");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.display_oled_angle_text=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("disp"),Blockly.Variables.NAME_TYPE);a=a.getFieldValue("action");return b+":setFontDirection("+a+")\n"};
Blockly.Blocks.display_oled_str={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/oled.jpg",15,15,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldVariable("item"),"disp");this.appendValueInput("text").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("texto:");this.appendValueInput("x0").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("x0:");
this.appendValueInput("y0").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("y0:");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.display_oled_str=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("disp"),Blockly.Variables.NAME_TYPE),c=Blockly.Lua.valueToCode(a,"text",Blockly.Lua.ORDER_ATOMIC),d=Blockly.Lua.valueToCode(a,"x0",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"y0",Blockly.Lua.ORDER_ATOMIC);return b+":drawStr("+d+", "+a+", "+c+")\n"};
Blockly.Blocks.display_oled_circ_disc={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/oled.jpg",15,15,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldVariable("item"),"disp");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldDropdown([["c\u00edrculo","drawCircle"],["disco","drawDisc"]]),"draw");this.appendValueInput("x0").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("x0:");
this.appendValueInput("y0").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("y0:");this.appendValueInput("radio").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("radio:");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.display_oled_circ_disc=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("disp"),Blockly.Variables.NAME_TYPE),c=a.getFieldValue("draw"),d=Blockly.Lua.valueToCode(a,"x0",Blockly.Lua.ORDER_ATOMIC),e=Blockly.Lua.valueToCode(a,"y0",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"radio",Blockly.Lua.ORDER_ATOMIC);return b+":"+c+"("+d+", "+e+", "+a+")\n"};
Blockly.Blocks.display_oled_frame_box={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/oled.jpg",15,15,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldVariable("item"),"disp");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldDropdown([["marco","drawFrame"],["caja","drawBox"]]),"draw");this.appendValueInput("x0").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("x0:");
this.appendValueInput("y0").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("y0:");this.appendValueInput("width").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("ancho:");this.appendValueInput("height").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("alto:");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.display_oled_frame_box=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("disp"),Blockly.Variables.NAME_TYPE),c=a.getFieldValue("draw"),d=Blockly.Lua.valueToCode(a,"x0",Blockly.Lua.ORDER_ATOMIC),e=Blockly.Lua.valueToCode(a,"y0",Blockly.Lua.ORDER_ATOMIC),f=Blockly.Lua.valueToCode(a,"width",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"height",Blockly.Lua.ORDER_ATOMIC);return b+":"+c+"("+d+", "+e+", "+f+", "+a+")\n"};
Blockly.Blocks.display_oled_line={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/oled.jpg",15,15,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldVariable("item"),"disp");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("L\u00ednea");this.appendValueInput("x0").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("x0:");this.appendValueInput("y0").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("y0:");
this.appendValueInput("x1").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("x1:");this.appendValueInput("y1").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("y1:");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.display_oled_line=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("disp"),Blockly.Variables.NAME_TYPE),c=Blockly.Lua.valueToCode(a,"x0",Blockly.Lua.ORDER_ATOMIC),d=Blockly.Lua.valueToCode(a,"y0",Blockly.Lua.ORDER_ATOMIC),e=Blockly.Lua.valueToCode(a,"x1",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"y1",Blockly.Lua.ORDER_ATOMIC);return b+"drawLine:("+c+", "+d+", "+e+", "+a+")\n"};
Blockly.Blocks.led_output={init:function(){this.appendDummyInput().appendField(new Blockly.FieldImage("./img/imag/led.svg",20,20,{alt:"*",flipRtl:"FALSE"})).appendField(new Blockly.FieldVariable("item"),"led").appendField(new Blockly.FieldDropdown([["ON","gpio.HIGH"],["OFF","gpio.LOW"],["TOGGLE","toggle"],["1","1"],["0","0"]]),"write");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip('Este bloque permite encender o apagar un led, los posibles valores son: ON y "1" para poner el led en alto o 1 l\u00f3gico, OFF y "0" para poner el led a 0 l\u00f3gico, mientras que TOGGLE intercambia el valor, es decir, si est\u00e1 encendido lo apaga y viceversa.');
this.setHelpUrl("")}};Blockly.Blocks.create_led={init:function(){this.appendValueInput("pin").setCheck("Number").appendField("Crear").appendField(new Blockly.FieldImage("./img/imag/led.svg",20,20,{alt:"*",flipRtl:"FALSE"})).appendField(new Blockly.FieldVariable("item"),"led").appendField("en");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl('Este bloque crea una salida para un LED. en "item" deber\u00e1 crear una variable que represente el LED, las variables se crean en la categor\u00eda variable, selecciones tambi\u00e9n el pin por donde saldr\u00e1 la se\u00f1al del LED (D0 hasta D10 o desde 0 hasta 10)')}};
Blockly.Lua.led_output=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("led"),Blockly.Variables.NAME_TYPE);a=a.getFieldValue("write");return"gpio.write("+b+", "+("toggle"==a?"(gpio.read("+b+") == 1 and gpio.LOW or gpio.HIGH)":a)+")\n"};Blockly.Lua.create_led=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("led"),Blockly.Variables.NAME_TYPE);a=Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC);return b+" = "+a+"\ngpio.mode("+b+", gpio.OUTPUT)\n"};Blockly.Blocks.init_tcp={init:function(){this.appendValueInput("timeout").setCheck("Number").appendField("Crear servidor").appendField(new Blockly.FieldDropdown([["TCP","net.TCP"],["UPD","net.UDP"]]),"type").appendField("timeout");this.setInputsInline(!0);this.setOutput(!0,null);this.setColour(265);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.init_tcp=function(a){var b=a.getFieldValue("type");a=Blockly.Lua.valueToCode(a,"timeout",Blockly.Lua.ORDER_ATOMIC);return[`net.createServer(${b}, ${a})
  `,Blockly.Lua.ORDER_NONE]};Blockly.Blocks.tcp_listen={init:function(){this.appendValueInput("var_port").setCheck(null).appendField(new Blockly.FieldVariable("item"),"server_tcp").appendField(", port");this.appendDummyInput().appendField("sck, datos");this.appendStatementInput("callback").setCheck(null);this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(265);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.tcp_listen=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("server_tcp"),Blockly.Variables.NAME_TYPE),c=Blockly.Lua.valueToCode(a,"var_port",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.statementToCode(a,"callback");return`if ${b} then
  ${b}:listen(${c}, function(sck)
    ${a} end)
end
`};Blockly.Blocks.tcp_events={init:function(){this.appendDummyInput().appendField(new Blockly.FieldDropdown([["enviado","sent"],["recibido","receive"],["conectado","conecction"],["desconectado","disconnection"],["reconectado","reconnection"]]),"events").appendField("datos");this.appendStatementInput("callback").setCheck(null);this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(265);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.tcp_events=function(a){var b=a.getFieldValue("events");a=Blockly.Lua.statementToCode(a,"callback");return`sck:on("${b}", function(sck, datos)
${a}end)
`};Blockly.Blocks.tcp_data={init:function(){this.appendDummyInput().appendField("dato sck");this.setOutput(!0,null);this.setColour(265);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.tcp_data=function(a){return["datos",Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.tcp_send={init:function(){this.appendValueInput("send_data").setCheck(null).appendField("sck enviar dato");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(265);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.tcp_send=function(a){return`sck:send(${Blockly.Lua.valueToCode(a,"send_data",Blockly.Lua.ORDER_ATOMIC)})
`};Blockly.Lua.pin_d=function(a){return[a.getFieldValue("number"),Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.pin_d={init:function(){this.appendDummyInput().appendField(new Blockly.FieldDropdown([["D0","0"],["D1","1"],["D2","2"],["D3","3"],["D4","4"],["D5","5"],["D6","6"],["D7","7"],["D8","8"],["D9","9"],["D10","10"]]),"number");this.setOutput(!0,null);this.setColour(210);this.setTooltip("Este bloque representa un pin en la tarjeta de desarrollo desde D0 hasta D10. Tener presente que las salidas se representan con n\u00fameros enteros, es decir, para D0 es 0 o para D9 es 9, as\u00ed se representa para los dem\u00e1s pines.");this.setHelpUrl("")}};
Blockly.Blocks.gpio_mode={init:function(){this.appendValueInput("pin").setCheck("Number").appendField("Modo Pin");this.appendDummyInput().appendField(new Blockly.FieldDropdown([["Entrada","gpio.INPUT"],["Salida","gpio.OUTPUT"],["Interrupci\u00f3n","gpio.INT"]]),"mode");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.gpio_mode=function(a){var b=Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC);a=a.getFieldValue("mode");return"gpio.mode("+b+", "+a+")\n"};
Blockly.Blocks.gpio_write={init:function(){this.appendValueInput("pin").setCheck("Number").appendField("Escribir Pin");this.appendDummyInput().appendField("a").appendField(new Blockly.FieldDropdown([["Alto","gpio.HIGH"],["Bajo","gpio.LOW"],["1","1"],["0","0"]]),"write");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.gpio_write=function(a){var b=Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC);a=a.getFieldValue("write");return"gpio.write("+b+", "+a+")\n"};
Blockly.Blocks.gpio_write_variable={init:function(){this.appendDummyInput().appendField("Escribir").appendField(new Blockly.FieldVariable("item"),"object").appendField("a").appendField(new Blockly.FieldDropdown([["Alto","gpio.HIGH"],["Bajo","gpio.LOW"],["1","1"],["0","0"]]),"write");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.gpio_write_variable=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("object"),Blockly.Variables.NAME_TYPE);a=a.getFieldValue("write");return"gpio.write("+b+", "+a+")\n"};
Blockly.Blocks.gpio_write_value={init:function(){this.appendValueInput("pin value").setCheck("Number").appendField("Escribir").appendField(new Blockly.FieldVariable("item"),"var_pin").appendField("a");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(210);this.setTooltip('Pone una variable "item" que representa un pin a un valor alto o bajo (1 o 0).');this.setHelpUrl("")}};
Blockly.Lua.gpio_write_value=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("var_pin"),Blockly.Variables.NAME_TYPE);a=Blockly.Lua.valueToCode(a,"pin value",Blockly.Lua.ORDER_ATOMIC);return"gpio.write("+b+", "+a+")\n"};
Blockly.Blocks.gpio_write_pin_value={init:function(){this.appendValueInput("pin name").setCheck("Number").appendField("Escribir Pin");this.appendValueInput("pin value").setCheck("Number").appendField("a");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(210);this.setTooltip("Pone un Pin a un valor alto o bajo (1 o 0).");this.setHelpUrl("")}};
Blockly.Lua.gpio_write_pin_value=function(a){var b=Blockly.Lua.valueToCode(a,"pin name",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"pin value",Blockly.Lua.ORDER_ATOMIC);return"gpio.write("+b+", "+a+")\n"};Blockly.Blocks.gpio_read={init:function(){this.appendValueInput("pin").setCheck("Number").appendField("Leer Pin");this.setInputsInline(!0);this.setOutput(!0,"Number");this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.gpio_read=function(a){return["gpio.read("+Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC)+")",Blockly.Lua.ORDER_NONE]};Blockly.Blocks.gpio_read_variable={init:function(){this.appendDummyInput().appendField("Leer").appendField(new Blockly.FieldVariable("item"),"Object");this.setInputsInline(!0);this.setOutput(!0,"Number");this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.gpio_read_variable=function(a){return["gpio.read("+Blockly.Lua.variableDB_.getName(a.getFieldValue("Object"),Blockly.Variables.NAME_TYPE)+")",Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.gpio_trig={init:function(){this.appendValueInput("pin").setCheck("Number").appendField("En pin");this.appendDummyInput().appendField("cuando").appendField(new Blockly.FieldDropdown([["sube","up"],["baja","down"],["ambos","both"],["nivel bajo","low"],["nivel alto","high"]]),"type");this.appendStatementInput("callback").setCheck(null);this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.gpio_trig=function(a){var b=Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC),c=a.getFieldValue("type");a=Blockly.Lua.statementToCode(a,"callback");return`gpio.trig(${b}, "${c}", function(level, when)
  ${a} end)
`};
Blockly.Blocks.gpio_trig_var={init:function(){this.appendDummyInput().appendField("En").appendField(new Blockly.FieldVariable("item"),"pin");this.appendDummyInput().appendField("cuando").appendField(new Blockly.FieldDropdown([["sube","up"],["baja","down"],["ambos","both"],["nivel bajo","low"],["nivel alto","high"]]),"type");this.appendStatementInput("callback").setCheck(null);this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.gpio_trig_var=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("pin"),Blockly.Variables.NAME_TYPE),c=a.getFieldValue("type");a=Blockly.Lua.statementToCode(a,"callback");return`gpio.trig(${b}, "${c}", function(level, when)
  ${a} end)
`};Blockly.Blocks.gpio_trig_level={init:function(){this.appendDummyInput().appendField("int.nivel");this.setInputsInline(!0);this.setOutput(!0,null);this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.gpio_trig_level=function(a){return["level",Blockly.Lua.ORDER_NONE]};Blockly.Blocks.gpio_trig_when={init:function(){this.appendDummyInput().appendField("int.cuando");this.setInputsInline(!0);this.setOutput(!0,null);this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.gpio_trig_when=function(a){return["when",Blockly.Lua.ORDER_NONE]};Blockly.Blocks.gpio_trig_compare={init:function(){this.appendDummyInput().appendField("tipo").appendField(new Blockly.FieldDropdown([["alto","high"],["bajo","low"]]),"level");this.setInputsInline(!0);this.setOutput(!0,null);this.setColour(210);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.gpio_trig_compare=function(a){return[`"${a.getFieldValue("level")}"`,Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.adc_read={init:function(){this.appendDummyInput().appendField("leer ADC");this.setOutput(!0,null);this.setColour(120);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.adc_read=function(a){return["adc.read(0)",Blockly.Lua.ORDER_NONE]};Blockly.Blocks.html_page={init:function(){this.appendDummyInput().appendField("HTML").appendField("T\u00edtulo:").appendField(new Blockly.FieldTextInput("Web"),"title");this.appendStatementInput("view").setCheck(null).appendField("Vista");this.appendStatementInput("logic").setCheck(null).appendField("L\u00f3gica");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(255);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.html_page=function(a){var b=a.getFieldValue("title"),c=Blockly.Lua.statementToCode(a,"view");return'srv=net.createServer(net.TCP)\nsrv:listen(80,function(conn)\n\tconn:on("receive", function(client,request)\n\t\tlocal _, _, method, path, vars = string.find(request, "([A-Z]+) (.+)?(.+) HTTP")\n\t\tif(method == nil)then\n\t\t\t_, _, method, path = string.find(request, "([A-Z]+) (.+) HTTP")\n\t\tend\n\t\tlocal _GET = {}\n\t\tif (vars ~= nil)then\n\t\t\tfor k, v in string.gmatch(vars, "(%w+)=(%w+)&*") do\n\t\t\t\t_GET[k] = v\n\t\t\tend\n\t\tend\n\t\tlocal _on,_off = "",""\n\t'+
Blockly.Lua.statementToCode(a,"logic")+'\t\tlocal _html = "<!DOCTYPE html>\\r\\n"\n\t\t.."<html>\\r\\n"\n\t\t.."<head>\\r\\n"\n\t\t.."<meta name=\\"viewport\\" charset=\\"utf-8\\" content=\\"width=device-width, initial-scale=1\\">\\r\\n"\n\t\t.."</head>\\r\\n"\n\t\t.."<body>\\r\\n"\n\t\t.."<h1>'+b+'</h1>\\r\\n"\n\t'+c+'\t\t.."</body>\\r\\n"\n\t\t.."</html>\\r\\n"\n\t\tlocal _http = "HTTP/1.1 200 OK\\r\\n"\n\t\t.."Content-Length: "..string.len(_html).."\\r\\n"\n\t\t.."Content-Type: text/html\\r\\n\\r\\n"\n\t\t.._html\n\t\tclient:send(_http)\n\t\tcollectgarbage()\n\tend)\nend)\n'};
Blockly.Blocks.html_button_view={init:function(){this.appendDummyInput().appendField("Bot\u00f3n").appendField(new Blockly.FieldDropdown([["0","0"],["1","1"],["2","2"],["3","3"],["4","4"],["5","5"],["6","6"],["7","7"],["8","8"],["9","9"],["10","10"],["11","11"],["12","12"]]),"number_button").appendField("Nombre:").appendField(new Blockly.FieldTextInput("Pulsador"),"name_button");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(255);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.html_button_view=function(a){var b=a.getFieldValue("number_button");a=a.getFieldValue("name_button");return'.."<p><a href=\\"?pin='+b+'\\"><button>'+a+'</button></a></p>\\r\\n"\n'};
Blockly.Blocks.html_button_logic={init:function(){this.appendDummyInput().appendField("Bot\u00f3n").appendField(new Blockly.FieldDropdown([["0","0"],["1","1"],["2","2"],["3","3"],["4","4"],["5","5"],["6","6"],["7","7"],["8","8"],["9","9"],["10","10"],["11","11"],["12","12"]]),"number_button");this.setOutput(!0,null);this.setColour(255);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.html_button_logic=function(a){return['_GET.pin == "'+a.getFieldValue("number_button")+'"',Blockly.Lua.ORDER_NONE]};Blockly.Blocks.html_text={init:function(){this.appendDummyInput().appendField("Texto Web:").appendField(new Blockly.FieldTextInput("Pagina Web"),"text_html");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(255);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.html_text=function(a){return'.."<p>'+a.getFieldValue("text_html")+'</p>\\r\\n"\n'};Blockly.Blocks.html_text_add_variable={init:function(){this.appendValueInput("input").setCheck(null).appendField("Texto Web + variable").appendField(new Blockly.FieldTextInput("Nombre de variable"),"name_variable");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(255);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.html_text_add_variable=function(a){var b=a.getFieldValue("name_variable");a=Blockly.Lua.valueToCode(a,"input",Blockly.Lua.ORDER_ATOMIC);return'.."<p>'+b+'"..'+a+'.."</p>\\r\\n"\n'};Blockly.Blocks.html_text_size={init:function(){this.appendValueInput("size").setCheck(null).appendField("Tama\u00f1o letra");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(255);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.html_text_size=function(a){return'.."<meta name=\\"viewport\\" content=\\"width=device-width, initial-scale='+Blockly.Lua.valueToCode(a,"size",Blockly.Lua.ORDER_ATOMIC)+'\\">\\r\\n"\n'};Blockly.Blocks.thingspeak={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Start ThingSpeak");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/ts.gif",100,25,"*"));this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(255);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.thingspeak=function(a){return'function sendData(apikey, datas)\nprint("Sending data to thingspeak.com")\nconn=net.createConnection(net.TCP, 0)\nconn:on("receive", function(conn, payload) print(payload) end)\nconn:connect(80,\'184.106.153.149\')\nconn:send("GET /update?key="..apikey..datas.." HTTP/1.1\\r\\n")\nconn:send("Host: api.thingspeak.com\\r\\n")\nconn:send("Accept: */*\\r\\n")\nconn:send("User-Agent: Mozilla/4.0 (compatible; esp8266 Lua; Windows NT 5.1)\\r\\n")\nconn:send("\\r\\n")\nconn:on("sent",function(conn)\nprint("Closing connection")\nconn:close()end)\nconn:on("disconnection", function(conn)\nprint("Got disconnection...")\nend)end\n'};
Blockly.Blocks.thingspeak_send={init:function(){this.appendValueInput("key").setCheck("String").setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/ts.gif",70,20,"*")).appendField("API Key");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Escribir variables a ThingSpeak");this.appendStatementInput("datas").setCheck(null);this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(255);
this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.thingspeak_send=function(a){var b=Blockly.Lua.valueToCode(a,"key",Blockly.Lua.ORDER_ATOMIC);return'myDatas = ""'+Blockly.Lua.statementToCode(a,"datas")+"\nsendData("+b+", myDatas)\n"};
Blockly.Blocks.thingspeak_field={init:function(){this.appendValueInput("field").setCheck("Number").setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/ts.gif",40,15,"*")).appendField(new Blockly.FieldDropdown([["field1",'"&field1="'],["field2",'"&field2="'],["field3",'"&field3="'],["field4",'"&field4="'],["field5",'"&field5="'],["field6",'"&field6="'],["field7",'"&field7="'],["field8",'"&field8="']]),"field");this.setInputsInline(!1);this.setPreviousStatement(!0,
null);this.setNextStatement(!0,null);this.setColour(255);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.thingspeak_field=function(a){var b=a.getFieldValue("field");a=Blockly.Lua.valueToCode(a,"field",Blockly.Lua.ORDER_ATOMIC);return".."+b+".."+a+'..\n""'};Blockly.Blocks.pwm_setup={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/PWM.gif",30,30,"*"));this.appendValueInput("pin").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("Pin:");this.appendValueInput("frec").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("Frecuencia:");this.appendValueInput("duty").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("Ciclo \u00fatil:");
this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.pwm_setup=function(a){var b=Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"frec",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"duty",Blockly.Lua.ORDER_ATOMIC);return"pwm.setup("+b+", "+c+", "+a+")\n"};
Blockly.Blocks.pwm_start={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("INICIAR");this.appendValueInput("pin").setCheck("Number").setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/PWM.gif",30,30,"*")).appendField("En pin:");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.pwm_start=function(a){return"pwm.start("+Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC)+")\n"};
Blockly.Blocks.pwm_stop={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("DETENER");this.appendValueInput("pin").setCheck("Number").setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/PWM.gif",30,30,"*")).appendField("En pin:");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.pwm_stop=function(a){return"pwm.stop("+Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC)+")\n"};
Blockly.Blocks.pwm_change_frecuency={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/PWM.gif",30,30,"*"));this.appendValueInput("pin").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("En pin:");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("CAMBIAR");this.appendValueInput("frec").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("Frecuencia:");this.setInputsInline(!1);
this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.pwm_change_frecuency=function(a){var b=Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"frec",Blockly.Lua.ORDER_ATOMIC);return"pwm.setclock("+b+", "+a+")\n"};
Blockly.Blocks.pwm_change_duty={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/PWM.gif",30,30,"*"));this.appendValueInput("pin").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("En pin:");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("CAMBIAR");this.appendValueInput("duty").setCheck(null).setAlign(Blockly.ALIGN_RIGHT).appendField("Ciclo \u00fatil:");this.setInputsInline(!1);
this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(290);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.pwm_change_duty=function(a){var b=Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"duty",Blockly.Lua.ORDER_ATOMIC);return"pwm.setduty("+b+", "+a+")\n"};Blockly.Blocks.midi={init:function(){this.appendDummyInput().appendField("MIDI");this.appendValueInput("status").setCheck("Number").appendField("Estado");this.appendValueInput("data1").setCheck("Number").appendField("Dato 1");this.appendValueInput("data2").setCheck("Number").appendField("Dato 2");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(265);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.midi=function(a){var b=Blockly.Lua.valueToCode(a,"status",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"data1",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"data2",Blockly.Lua.ORDER_ATOMIC);return"uart.write(0, string.char("+b+"), string.char("+c+"), string.char("+a+"))\n"};
Blockly.Blocks.service_osc_init={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Iniciar servicio OSC");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(160);this.setTooltip("Hace inicio del servicio OSC (control de sonido abierto), este protocolo permite la comunicaci\u00f3n de dispositivos en red para enviar y recibir datos.");this.setHelpUrl("")}};Blockly.Lua.service_osc_init=function(a){return"local sk_osc = net.createUDPSocket()\n"};
Blockly.Blocks.service_osc_listen={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Recibir por OSC");this.appendValueInput("port").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Puerto de escucha");this.appendDummyInput().appendField("Si recibe datos almacenar en OSC_IN y");this.appendStatementInput("received").setCheck(null).appendField("hacer");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(160);
this.setTooltip("Recibir datos por servicio OSC y almacenar en la variable OSC_IN, se requiere configurar un puerto de escucha, para hacer uso de OSC_IN buscar el bloque correspondiente en el toolbox.");this.setHelpUrl("")}};
Blockly.Lua.service_osc_listen=function(a){var b=Blockly.Lua.valueToCode(a,"port",Blockly.Lua.ORDER_ATOMIC);return"local osc_udp = {}\nlocal function receive(_, data)\n   osc_udp.a, osc_udp.i1, osc_udp.i2, osc_udp.f, osc_udp.s = osc.get_iifs(string.len(data), data)\n"+Blockly.Lua.statementToCode(a,"received")+"end\nsk_osc:listen("+b+')\nsk_osc:on("receve", receive)\n'};
Blockly.Blocks.osc_in_data={init:function(){this.appendDummyInput().appendField("OSC_IN.").appendField(new Blockly.FieldDropdown([["Direcci\u00f3n","a"],["1er entero","i1"],["2do entero","i2"],["Decimal","f"],["Texto","s"]]),"member");this.setOutput(!0,null);this.setColour(160);this.setTooltip("OSC_IN representa los datos que son recibidos por el protocolo OSC; OSC_IN.Direcci\u00f3n indica a qu\u00e9 elemento est\u00e1 dirigida la informaci\u00f3n, OSC_IN.1er o 2do entero son datos de n\u00fameros enteros, OSC_IN.Decimal es un dato en formato decimal y OSC_IN.Texto representa un dato de tipo Texto.");
this.setHelpUrl("")}};Blockly.Lua.osc_in_data=function(a){return["osc_udp."+a.getFieldValue("member"),Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.service_osc_send={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Enviar por OSC");this.appendValueInput("ip").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("IP");this.appendValueInput("port").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Puerto");this.appendValueInput("data").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Dato a enviar");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,
null);this.setColour(160);this.setTooltip("Recibir datos por servicio OSC y almacenar en la variable OSC_IN, se requiere configurar un puerto de escucha, para hacer uso de OSC_IN buscar el bloque correspondiente en el toolbox.");this.setHelpUrl("")}};
Blockly.Lua.service_osc_send=function(a){var b=Blockly.Lua.valueToCode(a,"ip",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"port",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"data",Blockly.Lua.ORDER_ATOMIC);return"sk_osc:send("+c+", "+b+", "+a+")\n"};
Blockly.Blocks.osc_format_iiff={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Formatear OSC");this.appendValueInput("address").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Direcci\u00f3n");this.appendValueInput("int1").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("1er entero");this.appendValueInput("int2").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("2do entero");this.appendValueInput("float1").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("1er decimal");
this.appendValueInput("float2").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("2do decimal");this.setInputsInline(!1);this.setOutput(!0,null);this.setColour(160);this.setTooltip("Este bloque permite dar formato a los datos que se desean enviar, siempre se requiere enviar la direcci\u00f3n, la direcci\u00f3n es un texto, por ejemplo: /piano, lo anterior indica que los datos son enviados a un piano. Use los datos que requiera enviar (no necesita llenarlos todos), cuando los reciba en el otro dispositivo, tenga encuenta el orden de los datos para poderlos usar y que tengan sentido.");
this.setHelpUrl("")}};Blockly.Lua.osc_format_iiff=function(a){var b=Blockly.Lua.valueToCode(a,"address",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"int1",Blockly.Lua.ORDER_ATOMIC),d=Blockly.Lua.valueToCode(a,"int2",Blockly.Lua.ORDER_ATOMIC),e=Blockly.Lua.valueToCode(a,"float1",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"float2",Blockly.Lua.ORDER_ATOMIC);return["osc.set_iiff("+b+", "+c+", "+d+", "+e+", "+a+")",Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.osc_format_ifs={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Formatear OSC");this.appendValueInput("address").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Direcci\u00f3n");this.appendValueInput("integer").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Entero");this.appendValueInput("float").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Decimal");this.appendValueInput("text").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Texto");
this.setInputsInline(!1);this.setOutput(!0,null);this.setColour(160);this.setTooltip("Este bloque permite dar formato a los datos que se desean enviar, siempre se requiere enviar la direcci\u00f3n, la direcci\u00f3n es un texto, por ejemplo: /piano, lo anterior indica que los datos son enviados a un piano. Use los datos que requiera enviar (no necesita llenarlos todos), cuando los reciba en el otro dispositivo, tenga encuenta el orden de los datos para poderlos usar y que tengan sentido.");this.setHelpUrl("")}};
Blockly.Lua.osc_format_ifs=function(a){var b=Blockly.Lua.valueToCode(a,"address",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"integer",Blockly.Lua.ORDER_ATOMIC),d=Blockly.Lua.valueToCode(a,"float",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"text",Blockly.Lua.ORDER_ATOMIC);return["osc.set_ifs("+b+", "+c+", "+d+", "+a+")",Blockly.Lua.ORDER_NONE]};Blockly.Blocks.function_map={init:function(){this.appendDummyInput().appendField("cambiar rango");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(285);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.function_map=function(a){return"function catalejo_map(x, x1, y1, x2, y2)\n  return (y2-y1)/(x2-x1)*(x - x1) + y1\nend\n"};
Blockly.Blocks.function_map_return={init:function(){this.appendDummyInput().appendField("cambiar rango");this.appendValueInput("x").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("variable:");this.appendValueInput("x1").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("x1:");this.appendValueInput("y1").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("y1:");this.appendValueInput("x2").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("x2:");this.appendValueInput("y2").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("y2:");
this.setOutput(!0,"Number");this.setColour(285);this.setInputsInline(!1);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.function_map_return=function(a){var b=Blockly.Lua.valueToCode(a,"x",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"x1",Blockly.Lua.ORDER_ATOMIC),d=Blockly.Lua.valueToCode(a,"y1",Blockly.Lua.ORDER_ATOMIC),e=Blockly.Lua.valueToCode(a,"x2",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"y2",Blockly.Lua.ORDER_ATOMIC);return[`catalejo_map(${b}, ${c}, ${d}, ${e}, ${a})`,Blockly.Lua.ORDER_NONE]};Blockly.Blocks.dht_read={init:function(){this.appendValueInput("pin").setCheck("Number").appendField(new Blockly.FieldImage("./img/imag/dht.gif",20,15,"*")).appendField("leer DHT en Pin");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(180);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.dht_read=function(a){return"dhtStatus, dhtTemp, dhtHum, dhtTemp_dec, dhtHum_dec = dht.read11("+Blockly.Lua.valueToCode(a,"pin",Blockly.Lua.ORDER_ATOMIC)+")\n"};
Blockly.Blocks.dht_view={init:function(){this.appendDummyInput().appendField(new Blockly.FieldImage("./img/imag/dht.gif",20,15,"*")).appendField("DHT.").appendField(new Blockly.FieldDropdown([["Temperatura","dhtTemp"],["Humedad","dhtHum"],["Estado sensor","dhtStatus"],["Temperatura decimal","dhtTemp_dec"],["Humedad decimal","dhtHum_dec"]]),"out");this.setOutput(!0,"Number");this.setColour(180);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.dht_view=function(a){return[a.getFieldValue("out"),Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.hcsr04_lib={init:function(){this.appendDummyInput().appendField(new Blockly.FieldImage("./img/imag/ultra.gif",30,15,{alt:"*",flipRtl:"FALSE"})).appendField("Lib ultrasonido");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(180);this.setTooltip("La librer\u00eda ultrasonido permite el uso de sensores de ultrasonido del tipo HCSR04. Debe quedar por encima de los bloques de creaci\u00f3n de ultrasonido");this.setHelpUrl("")}};
Blockly.Lua.hcsr04_lib=function(a){return'dofile("hcsr04.lc")\n'};
Blockly.Blocks.ultrasonic_setup={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Crear");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/ultra.gif",30,15,{alt:"*",flipRtl:"FALSE"})).appendField(new Blockly.FieldVariable("item"),"NAME");this.appendValueInput("trigger pin").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Trig");this.appendValueInput("echo pin").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("echo");
this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(180);this.setTooltip("Bloque permite crear un sensor ultrasonido hcsr04 a trav\u00e9s de sus pines echo y trigger, se puede seleccionar cualquier pin entre D1 a D10.");this.setHelpUrl("")}};
Blockly.Lua.ultrasonic_setup=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("NAME"),Blockly.Variables.NAME_TYPE),c=Blockly.Lua.valueToCode(a,"trigger pin",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"echo pin",Blockly.Lua.ORDER_ATOMIC);return b+" = HCSR04.new("+c+", "+a+")\n"};
Blockly.Blocks.ultrasonic_set={init:function(){this.appendDummyInput().appendField(new Blockly.FieldImage("./img/imag/ultra.gif",30,15,{alt:"*",flipRtl:"FALSE"})).appendField(new Blockly.FieldVariable("item"),"ultrasonic").appendField(new Blockly.FieldDropdown([["Emitir ultrasonido",".trigger()"],["Activar sensor",".activate()"],["Desactivar sensor",".deactivate()"]]),"option");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(180);this.setTooltip('Permite configurar el sensor dependiendo la opci\u00f3n seleccionada: Si selecciona la opci\u00f3n "Emitir ultrasonido" se da la orden de enviar una onda de sonido y preparar al sensor para detectar el eco de la misma. Las opciones otras opciones activan o desactivan el sensor de ultrasonido.');
this.setHelpUrl("")}};Blockly.Lua.ultrasonic_set=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("ultrasonic"),Blockly.Variables.NAME_TYPE);a=a.getFieldValue("option");return b+a+"\n"};
Blockly.Blocks.ultrasonic_get={init:function(){this.appendDummyInput().appendField(new Blockly.FieldImage("./img/imag/ultra.gif",30,15,{alt:"*",flipRtl:"FALSE"})).appendField(new Blockly.FieldVariable("item"),"ultrasonic").appendField(new Blockly.FieldDropdown([["Obtener distancia en cm",".measure()/10"],["Leer el estado del sensor",".status()"]]),"option");this.setOutput(!0,null);this.setColour(180);this.setTooltip('Si se selecciona la opci\u00f3n "Leer distancia en cm" se entrega el valor de la distancia obtenida de un objeto con el sensor, esta distancia se reporta en cm. Es importante reconocer que una lectura del sensor v\u00e1lida requiere monitorear el estado del sensor el cual se obtiene a trav\u00e9s de la opci\u00f3n "Leer el estado del sensor", el estado reportado tiene las siguientes opciones; -2: sensor activo, -1: Error en la lectura, 0: Distancia obtenida, 1: Lectura pendiente, 2: sensor desactivado.');
this.setHelpUrl("")}};Blockly.Lua.ultrasonic_get=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("ultrasonic"),Blockly.Variables.NAME_TYPE);a=a.getFieldValue("option");return[b+a,Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.ultrasonic_status={init:function(){this.appendDummyInput().appendField(new Blockly.FieldImage("./img/imag/ultra.gif",30,15,{alt:"*",flipRtl:"FALSE"})).appendField(new Blockly.FieldDropdown([["Tarea completada","0"],["Lectura en proceso","1"],["Error en la lectura","-1"],["Sensor activado","-2"],["Sensor desactivado","2"]]),"status");this.setOutput(!0,null);this.setColour(180);this.setTooltip("Es importante reconocer que una lectura del sensor v\u00e1lida requiere monitorear el estado del sensor, el estado reportado tiene las siguientes opciones; -2: sensor activo, -1: Error en la lectura, 0: Distancia obtenida, 1: Lectura pendiente, 2: sensor desactivado.");
this.setHelpUrl("")}};Blockly.Lua.ultrasonic_status=function(a){return[a.getFieldValue("status"),Blockly.Lua.ORDER_NONE]};
Blockly.Blocks.ultrasonic_if_status={init:function(){this.appendDummyInput().appendField("Si el sensor").appendField(new Blockly.FieldImage("./img/imag/ultra.gif",30,15,{alt:"*",flipRtl:"FALSE"})).appendField(new Blockly.FieldVariable("item"),"NAME");this.appendDummyInput().appendField("tiene el estado:").appendField(new Blockly.FieldDropdown([["Tarea completada","0"],["Lectura en proceso","1"],["Error en la lectura","-1"],["Sensor activado","-2"],["Sensor desactivado",
"2"]]),"status");this.appendStatementInput("do it").setCheck(null).appendField("Hacer");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(180);this.setTooltip('Este bloque permite realizar una tarea si el sensor ultrasonido se encuentra en el estado seleccionado. En "item" poner la variable del sensor iniciado, en estado seleccionar la opci\u00f3n que quiere comparar, en "hacer" poner la acci\u00f3n que quiere se realice si se cumple la condici\u00f3n a observar en el estado.');
this.setHelpUrl("")}};Blockly.Lua.ultrasonic_if_status=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("NAME"),Blockly.Variables.NAME_TYPE),c=a.getFieldValue("status");a=Blockly.Lua.statementToCode(a,"do it");return"if "+b+".status() == "+c+" then\n"+a+"end\n"};
Blockly.Blocks.ultrasonic_if_status_ok={init:function(){this.appendDummyInput().appendField("Si lectura en").appendField(new Blockly.FieldImage("./img/imag/ultra.gif",30,15,{alt:"*",flipRtl:"FALSE"})).appendField(new Blockly.FieldVariable("item"),"NAME");this.appendDummyInput().appendField("es completada con \u00e9xito");this.appendStatementInput("do it").setCheck(null).appendField("Hacer");this.appendDummyInput().appendField("Solicitar una nueva lectura").appendField(new Blockly.FieldCheckbox("TRUE"),
"trigger");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(180);this.setTooltip('Este bloque permite realizar una tarea cuando la lectura del sensor es completada satisfactoriamente. En "item" poner la variable del sensor iniciado, en "hacer" poner la acci\u00f3n que quiere se realice si se cumple la condici\u00f3n a observar en el estado, si quiere lecturas continuas del sensor active el check para realizar un nuevo trigger.');this.setHelpUrl("")}};
Blockly.Lua.ultrasonic_if_status_ok=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("NAME"),Blockly.Variables.NAME_TYPE),c=Blockly.Lua.statementToCode(a,"do it"),d="";"TRUE"===a.getFieldValue("trigger")==1&&(d="if "+b+".status() < 1 then\n\t"+b+".trigger()\nend\n");return"if "+b+".status() == 0 then\n"+c+"end\n"+d};
Blockly.Blocks.ds18b20_lib={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/termometro.png",25,25,"*")).appendField("Iniciar DS18B20");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("y guardar temperatura");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("En: ").appendField(new Blockly.FieldVariable("item"),"temp");this.setPreviousStatement(!0,null);this.setNextStatement(!0,
null);this.setColour(180);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.ds18b20_lib=function(a){a=Blockly.Lua.variableDB_.getName(a.getFieldValue("temp"),Blockly.Variables.NAME_TYPE);return`
file.remove("ds18b20_save.lc")
_ds18b20 = require("ds18b20")
function readout(temps_)
  i_ = 0
  for i, s in ipairs(ds18b20.sens) do
    i_ = i
  end
  if i_ == 1 then
    for _addr, _temp in pairs(temps_) do
      ${a} = _temp
    end
  else
    ${a} = -255
  end
end
`};
Blockly.Blocks.ds18b20_read={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/termometro.png",25,25,"*")).appendField("Leer DS18B20");this.appendValueInput("Pin").setCheck("Number").setAlign(Blockly.ALIGN_CENTRE).appendField("En el Pin");this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField("en la escala").appendField(new Blockly.FieldDropdown([["Celsius","ds18b20.C"],["Kelvin","ds18b20.K"],["Fahrenheit",
"ds18b20.F"]]),"scale");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(180);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};Blockly.Lua.ds18b20_read=function(a){var b=Blockly.Lua.valueToCode(a,"Pin",Blockly.Lua.ORDER_ATOMIC);a=a.getFieldValue("scale");return`_ds18b20:read_temp(readout, ${b}, ${a})
_ds18b20:read_temp(readout, ${b})
`};Blockly.Blocks.tmr_var={init:function(){this.appendValueInput("time").setCheck("Number").appendField("Esperar");this.appendDummyInput().appendField(new Blockly.FieldDropdown([["segundos","*1000000"],["milisegundos","*1000"],["microsegundos",""]]),"units");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(65);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.tmr_var=function(a){var b=Blockly.Lua.valueToCode(a,"time",Blockly.Lua.ORDER_ATOMIC);a=a.getFieldValue("units");return"tmr.delay("+b+a+")\n"};Blockly.Blocks.tmr_s={init:function(){this.appendValueInput("seconds").setCheck("Number").appendField("Esperar");this.appendDummyInput().appendField("(s)");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(65);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.tmr_s=function(a){return"tmr.delay("+1E6*Blockly.Lua.valueToCode(a,"seconds",Blockly.Lua.ORDER_ATOMIC)+")\n"};Blockly.Blocks.tmr_ms={init:function(){this.appendValueInput("miliseconds").setCheck("Number").appendField("Esperar");this.appendDummyInput().appendField("(ms)");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(65);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.tmr_ms=function(a){return"tmr.delay("+1E3*Blockly.Lua.valueToCode(a,"miliseconds",Blockly.Lua.ORDER_ATOMIC)+")\n"};Blockly.Blocks.tmr_us={init:function(){this.appendValueInput("microseconds").setCheck("Number").appendField("Esperar");this.appendDummyInput().appendField("(us)");this.setInputsInline(!0);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(65);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.tmr_us=function(a){return"tmr.delay("+Blockly.Lua.valueToCode(a,"microseconds",Blockly.Lua.ORDER_ATOMIC)+")\n"};
Blockly.Blocks.alarm_create={init:function(){this.appendDummyInput().appendField(new Blockly.FieldImage("./img/imag/timer.gif",30,30,"*")).appendField("Nombre de alarma:").appendField(new Blockly.FieldVariable("mi_alarma"),"name_alarm");this.appendValueInput("interval").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Intervalos en ms");this.appendStatementInput("NAME").setCheck(null);this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField("Repetir?").appendField(new Blockly.FieldDropdown([["Autom\u00e1tico",
"tmr.ALARM_AUTO"],["No","tmr.ALARM_SINGLE"],["Al llamar","tmr.ALARM_SEMI"]]),"NAME");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(65);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.alarm_create=function(a){var b=Blockly.Lua.variableDB_.getName(a.getFieldValue("name_alarm"),Blockly.Variables.NAME_TYPE),c=Blockly.Lua.valueToCode(a,"interval",Blockly.Lua.ORDER_ATOMIC),d=Blockly.Lua.statementToCode(a,"NAME");a=a.getFieldValue("NAME");return b+" = tmr.create()\n"+b+":register( "+c+", "+a+", function()\n"+d+"end)\n"};
Blockly.Blocks.alarm_start={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldImage("./img/imag/timer.gif",30,30,"*")).appendField("INICIAR").appendField(new Blockly.FieldVariable("mi_alarma"),"name_alarm");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(65);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.alarm_start=function(a){return Blockly.Lua.variableDB_.getName(a.getFieldValue("name_alarm"),Blockly.Variables.NAME_TYPE)+":start()\n"};
Blockly.Blocks.alarm_stop={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldImage("./img/imag/timer.gif",30,30,"*")).appendField("DETENER").appendField(new Blockly.FieldVariable("mi_alarma"),"name_alarm");this.setInputsInline(!1);this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(65);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.alarm_stop=function(a){return Blockly.Lua.variableDB_.getName(a.getFieldValue("name_alarm"),Blockly.Variables.NAME_TYPE)+":stop()\n"};Blockly.Blocks.wifi_sta={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/wifi_sta.gif",30,30,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("WiFi en modo estaci\u00f3n");this.appendValueInput("redName").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Nombre Red");this.appendValueInput("password").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Contrase\u00f1a");
this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(265);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.wifi_sta=function(a){var b=Blockly.Lua.valueToCode(a,"redName",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"password",Blockly.Lua.ORDER_ATOMIC);return"gpio.mode(4, gpio.OUTPUT)\ngpio.write(4,gpio.HIGH)\nwifi_alarm = tmr.create()\nwifi_alarm:register( 1000, tmr.ALARM_AUTO, function()\n\tif wifi.sta.status() == wifi.STA_CONNECTING then\n\t\tgpio.write(4,gpio.LOW)\n\t\twifi_alarm:stop()\n\tend\nend)\nstation_cfg={}\nstation_cfg.ssid="+b+"\nstation_cfg.pwd="+a+"\nstation_cfg.save=true\nwifi.sta.config(station_cfg)\nwifi.setmode(wifi.STATION)\nwifi_alarm:start()\n"};
Blockly.Blocks.wifi_ap={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/wifi_ap.gif",30,30,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("WiFi en modo punto de acceso");this.appendValueInput("redName").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Nombre Red");this.appendValueInput("password").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Contrase\u00f1a");
this.appendValueInput("channel").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Canal");this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(265);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.wifi_ap=function(a){var b=Blockly.Lua.valueToCode(a,"redName",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"password",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"channel",Blockly.Lua.ORDER_ATOMIC);return"cfg={}\ncfg.ssid="+b+"\ncfg.pwd="+c+"\ncfg.channel="+a+"\nwifi.ap.config(cfg)\nwifi.setmode(wifi.SOFTAP)\n"};
Blockly.Blocks.wifi_ap_sta={init:function(){this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("WiFi en ambos modos");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Como Punto de Acceso");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/wifi_ap.gif",30,30,"*"));this.appendValueInput("redNameAP").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Nombre Red");this.appendValueInput("passwordAP").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Contrase\u00f1a");
this.appendValueInput("channel").setCheck("Number").setAlign(Blockly.ALIGN_RIGHT).appendField("Canal");this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField(new Blockly.FieldImage("./img/imag/wifi_sta.gif",30,30,"*"));this.appendDummyInput().setAlign(Blockly.ALIGN_CENTRE).appendField("Como Estaci\u00f3n");this.appendValueInput("redNameSTA").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Nombre Red");this.appendValueInput("passwordSTA").setCheck("String").setAlign(Blockly.ALIGN_RIGHT).appendField("Contrase\u00f1a");
this.setPreviousStatement(!0,null);this.setNextStatement(!0,null);this.setColour(265);this.setTooltip("");this.setHelpUrl("http://www.example.com/")}};
Blockly.Lua.wifi_ap_sta=function(a){var b=Blockly.Lua.valueToCode(a,"redNameAP",Blockly.Lua.ORDER_ATOMIC),c=Blockly.Lua.valueToCode(a,"passwordAP",Blockly.Lua.ORDER_ATOMIC),d=Blockly.Lua.valueToCode(a,"channel",Blockly.Lua.ORDER_ATOMIC),e=Blockly.Lua.valueToCode(a,"redNameSTA",Blockly.Lua.ORDER_ATOMIC);a=Blockly.Lua.valueToCode(a,"passwordSTA",Blockly.Lua.ORDER_ATOMIC);return"station_cfg={}\nstation_cfg.ssid="+e+"\nstation_cfg.pwd="+a+"\ncfg.channel="+d+"\nstation_cfg.save=true\nwifi.sta.config(station_cfg)\ncfg={}\ncfg.ssid="+
b+"\ncfg.pwd="+c+"\nwifi.ap.config(cfg)\nwifi.setmode(wifi.STATIONAP)\n"};
